/* Node.js program */
import * as fs from 'fs';
import * as process from 'process';

import axios from "axios";
// https://developer.chrome.com/docs/puppeteer/
// Download problem: 'sudo npm i puppeteer@latest --unsafe-perm=true --allow-root'
// Check whether 'puppeteer.js' has been installed: 'npm list -depth=0'
import * as puppeteer from "puppeteer";

// brew install --cask chromium
// which chromium: '/usr/local/bin/chromium'

process.argv.forEach((value, index) => {
    console.log(`${index}: ${value}`);
});

class Google_Images {

    private static readonly _Database: string = './Database/';
    private static readonly _Path: string = '/search?tbm=isch&q=';
    private static readonly _URL: string = 'https://www.google.com';

    static async Take_picture() { // Returned type is inferred from 'async', i.e., 'Promise'
        const browser = await puppeteer.launch({headless: true}); // Launch 'Chrome' *with* visual environment
        // Following call *DOES NOT* occur (because of prior 'await') until prior one terminates:
        const page = await browser.newPage();
        await page.goto(Google_Images._URL + Google_Images._Path + (typeof process.argv[2] === 'string' ? process.argv[2] : '')); // By default, 'page.goto(...)' waits for the page load event
        const photo_file_name: String = (typeof process.argv[2] === 'string' ? process.argv[2] : 'undefined') + '.png';

        const body = await page.evaluate(() => document.body.innerHTML);
        const start_index: number = body.search("https://encrypted-tbn0.gstatic.com");
        if (start_index !== -1) {
            let image_URL = body.substring(start_index);
            image_URL = image_URL.substring(0, image_URL.search("\""));
            const blob: Blob = await axios.get(image_URL);
            fs.createWriteStream(Google_Images._Database + photo_file_name).write(blob);
        } else
            await page.screenshot({path: Google_Images._Database + photo_file_name}); // Default picture...
        await browser.close();
        return photo_file_name;
    }
}

Google_Images.Take_picture().then((photo_file_name) => {
    console.log('Photo file name: ' + photo_file_name);
});
